/***Copyright and coded by Dakusan, please do not steal code, but you may study and learn from it... Free to use and redistribute - See http://www.castledragmire.com/Copyright for more information. ***/
/***Dakusan's Video Thumbnailer - v1.0 http://www.castledragmire.com/Projects/Other_Web_Scripts#VideoThumbnailer ***/

//Configurable variables
var TempFillColor='#BBBBBB', SelectedFillColor='#154FE8';

//State variables
var PicLocs=['Fake'];
var InQuery=false;
var SelectedThumbs=[];
var CoverThumb='';

//Initialize default thumbs on page creation
function InitStartThumbs(StartLocs)
{
	//Initialize the thumbs
	for(var i=0;i<StartLocs.length;i++)
		AddThumbAfter(i, StartLocs[i], i==StartLocs.length-1, 1);
	
	//Remove the temporary fake thumb
	var Fake=document.getElementById('VTabFake');
	VTabFake.parentElement.removeChild(VTabFake);
	window.PicLocs.splice(0, 1);
	
	//Select initial thumbs
	for(var i=0;i<window.NumThumbsRequired;i++)
		SelectThumb(PicLocs[Math.ceil(i*(PicLocs.length-1)/window.NumThumbsRequired)], i+1==window.NumThumbsRequired);
	window.CoverThumb=window.PicLocs[0]; //Select the cover thumb
}

//Load a new thumbnail
function ThumbAddFunc(ThumbPos)
{
	try {
		//Do not allow multiple query calls at once
		if(window.InQuery)
		{
			alert('Please wait while the thumb loads');
			return false;
		}
		window.InQuery=true;
	
		//Find the new thumbnail to load
		var ThumbIndex=ArraySearch(window.PicLocs, ThumbPos);
		var NewPos=parseFloat(ThumbPos)/2+parseFloat(window.PicLocs[ThumbIndex+1])/2;
	
		//Call the server to create the new thumbnail
		GetURL('video_thumbs.php', {VideoID:window.VideoID, Pos:NewPos.toFixed(3)}, {CallBack:ThumbAddFunc_Return, ExtraData:ThumbIndex});
	}
	catch(e) { if(console && console.log) console.log(e); } //Log to console if available

	return false; //Return false so the HREF is not followed

}
function ThumbAddFunc_Return(Data, ThumbIndex)
{
	//Confirm the result is successful
	window.InQuery=false;
	if(Data.substr(0,2)!='SS')
		return alert(Data);
	AddThumbAfter(ThumbIndex, Data.substr(2), 0, 0);
}

//Add/Display a new thumbnail
function AddThumbAfter(ThumbIndex, NewPos, IsLastCell, IsStart)
{
	//Create the contents
	var Contents=('<table><tr>'+
				'<td><img src="?%.jpg" onclick="SelectThumb(\'%\', 1)"></td>'+(IsLastCell ? '' :
				'<td>--<a href="#" class="ThumbAdd" onclick="return ThumbAddFunc(\'%\')">+</a>--></td>')+
			'</tr><tr>'+
				'<td>'+FormatTime(NewPos)+'</td>'+
			'</tr></table>').replace(/\?/g, window.FileBase).replace(/%/g, NewPos);

	//Create the new table
	var NewTab=document.createElement('DIV');
	NewTab.id='VTab'+NewPos;
	NewTab.className='VideoTable';
	NewTab.innerHTML=Contents;
	DoInsertAfter(document.getElementById('VTab'+window.PicLocs[ThumbIndex]), NewTab);
	window.PicLocs.splice(ThumbIndex+1, 0, NewPos.toString()); //Add the position into the thumbnail list
	
	//If this is not part of the startup process, temporarily change the background color of the table
	if(!IsStart)
	{
		NewTab.style.backgroundColor=window.TempFillColor;
		var EraseColor=NewTab.style.backgroundColor;
		setTimeout(function() { ClearTempColor(NewTab, EraseColor); }, 1500);
	}
}
function ClearTempColor(NewTab, EraseColor) //Clear the new thumbnail background color
{
	if(NewTab.style.backgroundColor==EraseColor)
		NewTab.style.backgroundColor='';
}

//Select a thumbnail
function SelectThumb(Pos, RefreshTopList)
{
	//Add/Remove from the selected thumbnails list
	var CurIndex=ArraySearch(window.SelectedThumbs, Pos);
	if(CurIndex==-1)
	{
		window.SelectedThumbs.push(Pos);
		window.SelectedThumbs.sort(function(a,b){return parseFloat(a)<parseFloat(b) ? -1 : (parseFloat(a)==parseFloat(b) ? 0 : 1);});
	}
	else
		window.SelectedThumbs.splice(CurIndex.toString(), 1);

	//Change the background color to reflect selection
	document.getElementById('VTab'+Pos).style.backgroundColor=(CurIndex==-1 ? window.SelectedFillColor : '');
	
	//Make sure the cover thumb is still available and selected
	if(window.CoverThumb=='' || window.CoverThumb==Pos)
		window.CoverThumb=(window.SelectedThumbs.length==0 ? '' : window.SelectedThumbs[0]);

	//Refresh top thumbnails
	if(RefreshTopList)
		RefreshSelectedThumbs();
}

//Select the cover thumbnail
function SelectCoverThumb(Pos)
{
	if(window.CoverThumb==Pos)
		return;
	window.CoverThumb=Pos;
	RefreshSelectedThumbs();
}

//Display selected thumbnails at the top
function RefreshSelectedThumbs()
{
	//Generate the HTML
	var Contents=[];
	for(var i=0;i<window.SelectedThumbs.length;i++)
		Contents.push('<img src="'+FileBase+window.SelectedThumbs[i]+'.jpg"'+(window.SelectedThumbs[i]==window.CoverThumb ? ' style="background-color:red"' : '')+' onclick="SelectCoverThumb('+window.SelectedThumbs[i]+')"> ');
	Contents.push('<br /><font color="red">*Cover thumbnail is highlighted in red</font>');
	Contents.push('<br /><font size="+3" color="'+(window.SelectedThumbs.length!=window.NumThumbsRequired ? 'red' : 'green')+'">'+window.SelectedThumbs.length+'/'+window.NumThumbsRequired+' thumbs selected</font>');
	document.getElementById('SelectedThumbnails').innerHTML=Contents.join('');

	//Enable the submit button only if the correct number of thumbs have been selected
	document.getElementById('SubmitThumbsButton').disabled=(window.SelectedThumbs.length!=window.NumThumbsRequired);
}

//Submit the finalized thumbnails and cover thumb
function SubmitThumbs()
{
	//Do not allow multiple query calls at once
	if(window.InQuery)
		return alert('Please wait while the thumb loads');
	window.InQuery=true;

	GetURL('video_thumbs.php', {Submit:1, VideoID:window.VideoID, PicLocs:window.SelectedThumbs.join(','), CoverThumb:window.CoverThumb}, {CallBack:SubmitThumbs_Return});
}
function SubmitThumbs_Return(Data)
{
	//Confirm the result is successful
	window.InQuery=false;
	if(Data.substr(0,2)!='SS')
		return alert(Data);
	window.location.href=SuccessURL;
}

//Helper functions
function DoInsertAfter(OldEl, NewEl) //Insert a DOM element after another
{
	var P=OldEl.parentNode, N=OldEl.nextSibling;
	if(N===null)
		P.appendChild(NewEl);
	else
		P.insertBefore(NewEl, N);
}
function FormatTime(T) //Turn a a fractional second timestamp into a human readable timestamp (MM:SS.sss)
{
	T=parseFloat(T)*1000;
	Time=[1, 60, 60, 1000];
	for(var i=3;i>=0;i--)
	{
		var Interval=Time[i];
		T=(T-(Time[i]=T%Interval))/Interval;
	}
	return ZeroPad(Time[0]*60+Time[1], 2)+':'+ZeroPad(Time[2], 2)+'.'+ZeroPad(Time[3], 3);
}
function ZeroPad(S, Len) //Left zero pad a string
{
	S=S.toString();
	while(S.length<Len)
		S='0'+S;
	return S;
}
function ArraySearch(Arr, Value) //Search for a value in an array (since not all browsers have array.search available)
{
	for(var i in Arr)
		if(Arr[i]==Value)
			return parseInt(i, 10);
	return -1;
}