<?
/***Copyright and coded by Dakusan, please do not steal code, but you may study and learn from it... Free to use and redistribute - See http://www.castledragmire.com/Copyright for more information. ***/
/***Dakusan's Video Thumbnailer - v1.0 http://www.castledragmire.com/Projects/Other_Web_Scripts#VideoThumbnailer ***/

//Variables
$VideoThumbVars=Array(
	'BaseDir'		=> '.',			//Base directory where videos are stored
	'ThumbsDir'		=> './VideoThumbs',	//Where final thumbs are stored
	'ThumbsTempDir'		=> './VideoThumbs/Temp',//Where temp thumbs are stored - This will need to be periodically purged
	'DefaultFramesToExtract'=> 30,			//Number of frames to extract by default
	'MinInterval'		=> .5,			//The smallest seconds interval allowed between frames
	'MaxInterval'		=> 3,			//The largest seconds interval allowed between frames
	'MaxWidth'		=> 150,			//Maximum pixel width
	'MaxHeight'		=> 150,			//Maximum pixel height
	'NumThumbsRequired'	=> 6,			//Number of thumbs required for submission
	'SuccessURL'		=> 			//The location to forward to on successful submission. This can be a javascript script as is demonstrated by the default
		'javascript:alert("Success (Do something here like forward to another URL)");',
	
	//VBulletin variables (only used if UsingVBB is TRUE)
	'UsingVBB'		=> FALSE,		//If this page is being rendered in VBulletin
	'VBBTemplateName'	=> 'video_thumbs',	//A template of this name must be created in VBB which outputs the "$Output" variable
	'VBBDLFilesTable'	=> 'dl_files',		//The name of the download files table
	'VBBDLThumbsTable'	=> 'dl_thumbs',		//The name of the thumbnails table (created by this script)
	'VBBVideoCategories'	=> Array(),		//Category IDs that the file can belong to
	'VBBUserGroupIDs'	=> Array()		//Group IDs that a user can belong to whom can process all videos
);

//Prepare for vbulletin
if($VideoThumbVars['UsingVBB'])
{
	define('THIS_SCRIPT', $VideoThumbVars['VBBTemplateName']);
	require_once('./global.php');
	$navbits=Array($parent=>'Create Video Thumbnails');

	//Hijack SQL connection
	require_once('SQL.php');
	$SQLInfo=Array('Reference'=>$db->connection_master, 'Count'=>1); //Transfer mysqli object to different framework
}

//Handle different kinds of requests
if(isset($_REQUEST['Submit'])) //Final submission
	print Submit();
else if(isset($_REQUEST['QuickCreate'])) //Quick thumbnail creation
{
	if(($Output=ConfirmPermissions())===FALSE && is_array($Output=GetThumbList(true)))
	{
		$_REQUEST['PicLocs']=implode(',', $Output);
		$_REQUEST['CoverThumb']=$Output[ceil($VideoThumbVars['NumThumbsRequired']/2)-1];
		$Output=Submit();
	}
	print $Output;
}
else if(!isset($_REQUEST['Pos'])) //Page request
{
	//Get the page output
	if(($Output=ConfirmPermissions())===FALSE && is_array($Output=GetThumbList(false)))
		$Output=VidThumbs_HTMLCode(implode(',', $Output));

	//Output the page
	if($VideoThumbVars['UsingVBB']) //In the vbulletin format
	{
		$navbits=construct_navbits($navbits);
		eval('$navbar="'.fetch_template('navbar').'";');
		eval('print_output("'.fetch_template('VIDEO_THUMBS').'");');
	}
	else //By itself
		print $Output;
}
else //Individual thumbnail request
	print CreateThumbnail();

//Worker functions
function ConfirmPermissions() //Confirm user permissions and file status. Also gets the base filename
{
	global $VideoThumbVars;
	if($VideoThumbVars['UsingVBB']) //Check VBB permissions
	{
		//Confirm a valid video was requested
		global $vbulletin;
		if(!isset($_REQUEST['VideoID']) || !preg_match('/^\d+$/D', $_REQUEST['VideoID']))
			return 'Valid video ID not given';

		//Confirm the video in the database
		if(($VidData=MysqlFetchData(MysqlQuery('SELECT uploaderid, url, category FROM `'.$VideoThumbVars['VBBDLFilesTable'].'` WHERE id=?', $_REQUEST['VideoID']), 0))===FALSE)
			return 'Video not found';
		if(!in_array($VidData['category'], $VideoThumbVars['VBBVideoCategories']))
			return 'Download file is not in a video category';
		$VideoThumbVars['VidFileName']=$VidFileName=$VidData['url'];

		//Confirm user permission
		if($VidData['uploaderid']!=$vbulletin->userinfo['userid'] && !in_array($vbulletin->userinfo['usergroupid'], $VideoThumbVars['VBBUserGroupIDs']))
			return 'You do not have access to this video';
	}
	else if(!isset($_REQUEST['VideoID']))
		return 'Video name not given';
	else
		$VideoThumbVars['VidFileName']=$VidFileName=$_REQUEST['VideoID'];
	
	//Confirm filename and get its base
	if(preg_match('/[\/\*\\\\]/', $VidFileName))
		return 'Filename cannot contain slashes or asterisks';
	$VideoThumbVars['FileBase']=(preg_match('/^(.+)\.[^\.]*$/D', $VidFileName, $Matches) ? $Matches[1] : $VidFileName); //Extract the filename without the extension
	
	return FALSE;
}

function GetVideoInfo($Path, $MaxWidth, $MaxHeight) //Get video duration, width, height, and escape shell arg path
{
	//Confirm video and extract parameters
	if(!file_exists($Path))
		return 'Video file not found';
	$SafeVidPath=escapeshellarg($Path);
	if(($VideoInfo=shell_exec("ffmpeg -i $SafeVidPath 2>&1"))=='')
		return 'Could not extract video info';
	if(!preg_match('/^\s*Duration: (\d+:\d+:\d+\.\d+)/m', $VideoInfo, $Duration))
		return 'Could not find video length';
	if(!preg_match('/^\s*Stream.*?Video:.*?(\d+x\d+)/m', $VideoInfo, $Dimensions))
		return 'Could not find video dimensions';

	//Extract the final dimensions (width x height in pixels) and duration (in seconds)
	$Duration=preg_split('/\D/', $Duration[1]);
	$Duration=($Duration[0]*60+$Duration[1])*60+$Duration[2]+(str_pad($Duration[3], 3, '0', STR_PAD_LEFT)/1000.0)-.001; //Subtract 1MS for rounding errors
	$Dimensions=explode('x', $Dimensions[1]);
	$DConstraint=($Dimensions[0]/$MaxWidth>$Dimensions[1]/$MaxHeight);
	$Width= ( $DConstraint ? $MaxWidth  : intval($MaxHeight/$Dimensions[1]*$Dimensions[0]));
	$Height=(!$DConstraint ? $MaxHeight : intval($MaxWidth /$Dimensions[0]*$Dimensions[1]));
	return Array('Duration'=>$Duration, 'Width'=>$Width, 'Height'=>$Height, 'SafeVidPath'=>$SafeVidPath);
}

function CreateThumbnail() //A single thumbnail creation request
{
	//Confirm permissions
	if(($Output=ConfirmPermissions())!==FALSE)
		return $Output;
	if(!preg_match('/^\d+\.\d+$/D', $_REQUEST['Pos'])) //Confirm position parameter
		return 'Invalid Position';
	
	//Get variables
	global $VideoThumbVars;
	extract($VideoThumbVars);

	//If thumbnail already exists, just return success
	$TimeLocation=sprintf('%.3f', $_REQUEST['Pos']);
	if(file_exists($ThumbLoc="$ThumbsTempDir/$FileBase-$TimeLocation.jpg"))
		return 'SS'.$TimeLocation;
	
	//Get the video information
	if(!is_array($VidInfo=GetVideoInfo("$BaseDir/$VidFileName", $MaxWidth, $MaxHeight)))
		return $VidInfo;
	extract($VidInfo);
	if($_REQUEST['Pos']>$Duration)
		return 'Invalid position';
	
	//Create the thumbnail
	if(!is_dir($ThumbsTempDir))
		mkdir($ThumbsTempDir, 0777, true);
	if(($ProcHandle=CreateFrame($SafeVidPath, $ThumbLoc, $Width, $Height, ExtractTime($TimeLocation)))!==FALSE) //If the process was created, wait until it is closed
		proc_close($ProcHandle);
	
	return 'SS'.$TimeLocation;
}


function GetThumbList($AutoCreateThumbs) //Get list of thumbs to show and create them
{
	//Get variables
	global $VideoThumbVars;
	extract($VideoThumbVars);
	
	//Get the video information
	if(!is_array($VidInfo=GetVideoInfo("$BaseDir/$VidFileName", $MaxWidth, $MaxHeight)))
		return $VidInfo;
	extract($VidInfo);

	//Determine the frame locations and intervals ...
	if($AutoCreateThumbs) //... to process for auto creation
	{
		$NumFrames=$NumThumbsRequired;
		$FrameInterval=$Duration/($NumThumbsRequired-1);
	}
	else //... to display by default
	{
		$VidLenCat=($Duration<($DefaultFramesToExtract-1)*$MinInterval ? 0 : ($Duration>($DefaultFramesToExtract-1)*$MaxInterval ? 2 : 1)); //0=Min interval hit, 1=no constraining interval hit, 2=max interval hit
		$FrameInterval=($VidLenCat==1 ? $Duration/($DefaultFramesToExtract-1) : ($VidLenCat==0 ? $MinInterval : $MaxInterval));
		$NumFrames=floor($Duration/$FrameInterval)+1;
	}

	//Determine the thumbnail locations and create them
	$PicLocs=Array(); $ProcHandles=Array();
	if(!is_dir($ThumbsTempDir))
		mkdir($ThumbsTempDir, 0777, true);
	$NumCreated=0;
	for($i=0;$i<$NumFrames;$i++)
	{
		$TimeLocation=sprintf('%.3f', $i*$FrameInterval);
		$ProcHandles[]=CreateFrame($SafeVidPath, "$ThumbsTempDir/$FileBase-$TimeLocation.jpg", $Width, $Height, ExtractTime($TimeLocation));
		$PicLocs[]=$TimeLocation;
	}
	
	//Wait for all processes to finish
	foreach($ProcHandles as $ProcHandle)
		if($ProcHandle!==FALSE) //If the process was created, wait until it is closed
			proc_close($ProcHandle);
	
	return $PicLocs;
}

function CreateFrame($SafeInFile, $OutFile, $Width, $Height, $TimeLoc) //Create a thumbnail in a separate process. Non-blocking processes are used to help parallelize things
{
	if(file_exists($OutFile))
		return FALSE;
	$Command="ffmpeg -i $SafeInFile -vframes 1 -s '${Width}x$Height' -ss '". sprintf("%02d:%02d:%02d.%03d", $TimeLoc[0], $TimeLoc[1], $TimeLoc[2], $TimeLoc[3])."' ".escapeshellarg($OutFile).' 2>&1';
	return proc_open($Command, Array(1=>array('pipe', 'w')), $Pipes);
}

function ExtractTime($T) //Extract the milliseconds, seconds, minutes, and hours from a fractional second timestamp
{
	$T*=1000;
	$Time=Array(1, 60, 60, 1000);
	for($i=3;$i>=0;$i--)
	{
		$Interval=$Time[$i];
		$T=($T-($Time[$i]=$T % $Interval))/$Interval;
	}
	return $Time;
}

function VidThumbs_HTMLCode($PicLocs) //Create the HTML/JS/CSS for the base page
{
	global $VideoThumbVars;
	require_once('SQL.php');
	return <<<VIDTHUMBS
<style type="text/css">
.VideoTable { float:left; margin-left:5px; padding:3px; }
.ThumbAdd { text-decoration:none; color:tomato !important; }
#SelectedThumbnails img { padding:3px; border:3px solid white; background-color:black; }
</style>

<table><tr><td>
<u><b>Selected thumbnails:</b></u><br /><br />
<div id="SelectedThumbnails">...</div>
<input type="button" value="Submit" onclick="SubmitThumbs()" id="SubmitThumbsButton" />
<hr style="margin-bottom:20px;" />
<font size="+3">Choose the $VideoThumbVars[NumThumbsRequired] thumbnails below for the video</font><br />

<font color="red">*Click on a thumbnail to toggle its selection.<br />*Click on a red + sign to add a thumbnail whose time marker is halfway in between its siblings.</font><br /><br />
<div class="VideoTable" id="VTabFake"><table><tr><td>Loading initial thumbs...</td></tr></table></div>
</td></tr></table>

<script type="text/javascript" src="AJAX.js"></script>
<script type="text/javascript" src="video_thumbs.js"></script>
<script type="text/javascript">
VIDTHUMBS
."
var VideoID=".EJS($_REQUEST['VideoID']).";
var FileBase='".EHTML("${VideoThumbVars['ThumbsTempDir']}/${VideoThumbVars['FileBase']}-")."';
var SuccessURL=".EJS($VideoThumbVars['SuccessURL']).";
var NumThumbsRequired=$VideoThumbVars[NumThumbsRequired];
InitStartThumbs('$PicLocs'.split(','));
</script>
";
}

function Submit() //Finalize the process after the thumbs have been chosen
{
	//Confirm permission
	if(($Output=ConfirmPermissions())!==FALSE)
		return $Output;

	//Get variables
	global $VideoThumbVars;
	extract($VideoThumbVars);

	//Gather and confirm thumbnails to use
	if(!isset($_REQUEST['PicLocs']))
		return 'Picture locations not provided';
	$PicLocs=explode(',', $_REQUEST['PicLocs']);
	if(count($PicLocs)!=$NumThumbsRequired)
		return 'Exactly '.$NumThumbsRequired.' thumbnails expected';
	if(count(array_unique($PicLocs))!=$NumThumbsRequired)
		return 'Cannot use a thumbnail more than once';
	foreach($PicLocs as $PicLoc)
		if(!preg_match('/^\d+\.\d+$/D', $PicLoc)) //Confirm position
			return 'Invalid Position: '.$PicLoc;
		else if(!file_exists("$ThumbsTempDir/$FileBase-$PicLoc.jpg"))
			return 'Cannot find position: '.$PicLoc;
	sort($PicLocs, SORT_NUMERIC); //Make sure they are sorted numerically
	
	//Confirm cover thumb
	if(!isset($_REQUEST['CoverThumb']) || !preg_match('/^\d+(\.\d+)?$/D', $_REQUEST['CoverThumb']))
		return 'Invalid cover thumb';
	else if(!in_array($_REQUEST['CoverThumb']=sprintf('%.3f', $_REQUEST['CoverThumb']), $PicLocs))
		return 'Cover pic is not in the thumbnail list';
	
	//Move chosen thumbnails to the permanent directory and delete the rest of the temp images
	foreach($PicLocs as $PicLoc)
		rename("$ThumbsTempDir/$FileBase-$PicLoc.jpg", "$ThumbsDir/$FileBase-$PicLoc.jpg");
	foreach(glob("$ThumbsTempDir/$FileBase-*.jpg", GLOB_NOSORT) as $FileName)
		unlink($FileName);
	
	//Nothing left to do if not using VBB	
	if(!$UsingVBB)
		return 'SS';
	
	//Make sure the table has been created
	if(!count(MysqlFetchData(MysqlQuery("SHOW TABLES LIKE '$VBBDLThumbsTable'"))))
	{
		MysqlQuery("CREATE TABLE `$VBBDLThumbsTable` (id int(10) unsigned NOT NULL, position float NOT NULL, PRIMARY KEY (id, position)) ENGINE=MYISAM"); //The cover picture is the negative position
		if(!count(MysqlFetchData(MysqlQuery("SHOW TABLES LIKE '$VBBDLThumbsTable'"))))
			return 'Cannot create thumbnail table';
	}
	
	//Insert positions into the thumbnail table
	MysqlQuery("DELETE FROM `$VBBDLThumbsTable` WHERE id=?", $_REQUEST['VideoID']); //Remove old positions from the thumbnail table
	foreach($PicLocs as $PicLoc)
		MysqlQuery("INSERT INTO `$VBBDLThumbsTable` VALUES (?, ?)", $_REQUEST['VideoID'], $PicLoc*($PicLoc==$_REQUEST['CoverThumb'] ? -1 : 1));

	//Return success
	return 'SS';
}
?>